<?php
require_once(PATH_t3lib.'class.t3lib_rteapi.php');
require_once(PATH_t3lib.'class.t3lib_cs.php');

class tx_tinyrte extends t3lib_rteapi {

	/**
	 * Is the browser able to display the RTE? (Not implemented yet. Coming soon...
	 */
	function isAvailable()	{


	return true;
	}


	/**
	 * Draws the RTE
	 *
	 * @param	object		Reference to parent object, which is an instance of the TCEforms.
	 * @param	string		The table name
	 * @param	string		The field name
	 * @param	array		The current row from which field is being rendered
	 * @param	array		Array of standard content for rendering form fields from TCEforms. See TCEforms for details on this. Includes for instance the value and the form field name, java script actions and more.
	 * @param	array		"special" configuration - what is found at position 4 in the types configuration of a field from record, parsed into an array.
	 * @param	array		Configuration for RTEs; A mix between TSconfig and otherwise. Contains configuration for display, which buttons are enabled, additional transformation information etc.
	 * @param	string		Record "type" field value.
	 * @param	string		Relative path for images/links in RTE; this is used when the RTE edits content from static files where the path of such media has to be transformed forth and back!
	 * @param	integer		PID value of record (true parent page id)
	 * @return	string		HTML code for RTE!
	 */
	function drawRTE(&$pObj,$table,$field,$row,$PA,$specConf,$thisConfig,$RTEtypeVal,$RTErelPath,$thePidValue)	{
		global $BE_USER,$LANG;
		$tf=array(
			"0" => "false",
			"1" => "true",
		);
		/**
		 * get the language
		 */
		$this->language = $LANG->lang;
		if ($this->language=='default' || !$this->language)	{
			$this->language='en';
		}

		/**
		 * Path
		 */
		$this->httpTypo3Path = substr( substr( t3lib_div::getIndpEnv('TYPO3_SITE_URL'), strlen( t3lib_div::getIndpEnv('TYPO3_REQUEST_HOST') ) ), 0, -1 );
		if (strlen($this->httpTypo3Path) == 1) {
			$this->httpTypo3Path = "/";
		} else {
			$this->httpTypo3Path .= "/";
		}
		$this->Path = $this->httpTypo3Path . t3lib_extMgm::siteRelPath("tinyrte");

		/**
		 * Configure the RTE
		 */ 
		$globalConf=unserialize($GLOBALS["TYPO3_CONF_VARS"]["EXT"]["extConf"]["tinyrte"]);
		$value = $this->transformContent('rte',$PA['itemFormElValue'],$table,$field,$row,$specConf,$thisConfig,$RTErelPath,$thePidValue);
			//Convert Typo3 TSConfig-Names to tinyMCE-Names and add the plugin it depends on to remove from the pluginlist
		$cNames=array(
			"cut" => array(
				"mce" => "cut",
				"ext" => ""
			),
			"copy" => array(
				"mce" => "copy",
				"ext" => ""
			),
			"paste"	=> array(
				"mce" => "paste",
				"ext" => "paste"
			),
			"formatblock" => array(
				"mce" => "justifyfull",
				"ext" => ""
			),
			"class"	=> array(
				"mce" => "formatselect",
				"ext" => ""
			),
			"fontstyle" => array(
				"mce" => "fontselect",
				"ext" => ""
			),
			"fontsize" => array(
				"mce" => "fontsizeselect",
				"ext" => ""
			),
			"textcolor" => array(
				"mce" => "forecolor",
				"ext" => ""
			),
			"bold" => array(
				"mce" => "bold",
				"ext" => ""
			),
			"italic" => array(
				"mce" => "italic",
				"ext" => ""
			),
			"underline" => array(
				"mce" => "underline",
				"ext" => ""
			),
			"left" => array(
				"mce" => "justifyleft",
				"ext" => ""
			),
			"center" => array(
				"mce" => "justifycenter",
				"ext" => ""
			),
			"right"	=> array(
				"mce" => "justifyright",
				"ext" => ""
			),
			"orderedlist" => array(
				"mce" => "numlist",
				"ext" => ""
			),
			"unorderedlist"	=> array(
				"mce" => "bullist",
				"ext" => ""
			),
			"outdent" => array(
				"mce" => "outdent",
				"ext" => ""
			),
			"indent" => array(
				"mce" => "indent",
				"ext" => ""
			),
			"link" => array(
				"mce" => "link",
				"ext" => "advlink"
			),
			"table"	=> array(
				"mce" => "table",
				"ext" => "table"
			),
			"bgcolor" => array(
				"mce" => "backcolor",
				"ext" => ""
			),
			"image"	=> array(
				"mce" => "image",
				"ext" => "advimage"
			),
			"emoticon" => array(
				"mce" => "emotions",
				"ext" => "emotions"
			),
			"line" => array(
				"mce" => "hr",
				"ext" => "advhr"
			),
			"chMode" => array(
				"mce" => "code",
				"ext" => ""
			),
		);
		$hide=explode(",",str_replace(" ","",strtolower($thisConfig["hideButtons"])));
		$extNotAllowed=array();
		for ($i = 1; $i <= 4; $i++) {
			reset($cNames);
			while (list($t3Name, $mceName) = each($cNames)) {
				if(in_array($t3Name,$hide)) {
					$globalConf["MCEbuttons$i"]=str_replace($mceName["mce"].",","",$globalConf["MCEbuttons$i"]);
					if(!in_array($mceName["ext"],$extNotAllowed)) $extNotAllowed[]=$mceName["ext"];
				}
			}
		}
		/**
		 * TinyMCE-Plugins to load
		 * If an Feature removed by TSConfig the Plugin (if exist) should also be removed to prevent faster load
		 */ 
		if(!$globalConf["MCEplugin"]) { // Set to nothing => load all found
			$plugPath=substr($GLOBALS["PATH_TRANSLATED"],0,strlen($GLOBALS["PATH_TRANSLATED"])-strlen($GLOBALS["SCRIPT_NAME"])).$this->httpTypo3Path.t3lib_extMgm::siteRelPath("tinyrte")."tiny_mce/plugins";
			$plugs=t3lib_div::get_dirs($plugPath);
			if(is_array($plugs)) {
				while (list(, $val) = each($plugs)) {
					$plugins.=$val.",";
				}
				$globalConf["MCEplugin"]=substr($plugins,0,strlen($plugins)-1);
			}
		}
		if(is_array($extNotAllowed)) {
			while (list(, $remove) = each($extNotAllowed)) {
				if($remove) $globalConf["MCEplugin"]=str_replace($remove.",","",$globalConf["MCEplugin"]);
			}
		}
		// Inlinepopups???
		$globalConf["MCEplugin"]=str_replace("inlinepopups,","",$globalConf["MCEplugin"]);
		$globalConf["MCEplugin"]=str_replace("inlinepopups","",$globalConf["MCEplugin"]);
		if($tf[$globalConf["MCEinlinepopups"]]) $globalConf["MCEplugin"].=",inlinepopups";

		/**
		 * Load the RTE
		 */
		$item='
		<script language="javascript" type="text/javascript" src="'.$this->Path.'tiny_mce/tiny_mce.js"></script>
		<script language="javascript" type="text/javascript">
			tinyMCE.init({
				cleanup : true,
				remove_script_host : false,
				relative_urls : false,
				mode : "exact",
				extended_valid_elements : "hr[class|width|size|noshade],help",
				file_browser_callback : "fileBrowserCallBack",
				elements : "RTEarea'.$pObj->RTEcounter.'",
				theme : "advanced",
				language : "'.$this->language.'",
				entities : "'.$globalConf["MCEentities"].'",
				width : "'.$globalConf["MCEwidth"].'",
				height : "'.$globalConf["MCEheight"].'",
				convert_newlines_to_brs : '.$tf[$globalConf["MCEconvert_newlines_to_brs"]].',
				force_p_newlines : '.$tf[$globalConf["MCEforce_p_newlines"]].',
				force_br_newlines : '.$tf[$globalConf["MCEforce_br_newlines"]].',
				editor_css : "'.$globalConf["MCEstyle"].'",
				theme_advanced_resizing : '.$tf[$globalConf["MCEtheme_advanced_resizing"]].',
				theme_advanced_resize_horizontal : '.$tf[$globalConf["MCEtheme_advanced_resize_horizontal"]].',
				theme_advanced_buttons1 : "'.str_replace("|","seperator",$globalConf["MCEbuttons1"]).'",
				theme_advanced_buttons2 : "'.str_replace("|","seperator",$globalConf["MCEbuttons2"]).'",
				theme_advanced_buttons3 : "'.str_replace("|","seperator",$globalConf["MCEbuttons3"]).'",
				theme_advanced_buttons4 : "'.str_replace("|","seperator",$globalConf["MCEbuttons4"]).'",
				theme_advanced_toolbar_location : "top",
				theme_advanced_toolbar_align : "left",
				theme_advanced_statusbar_location : "bottom",
			        plugin_insertdate_dateFormat : "'.$globalConf["MCEplugin_insertdate_dateFormat"].'",
			        plugin_insertdate_timeFormat : "'.$globalConf["MCEplugin_insertdate_timeFormat"].'",
				plugins : "'.$globalConf["MCEplugin"].'"
				//verify_html : true,
				//encoding : "xml", 
				//cleanup_on_startup : true,
				//apply_source_formatting : true,
				//paste_use_dialog : true
				//theme_advanced_styles : "Header 1=header1;Header 2=header2;Header 3=header3;Table Row=tableRow1",
			});

		
			
			/**
			 * Here are the additional Typo3-Functions
			 * At this time only "type" is used to
			 * manage Link or Image functions
			 */
			function fileBrowserCallBack(field_name, url, type, win) {
				var template = new Array();
				template["width"] = 500;
				template["height"] = 300;
				var editor_id="RTEarea'.$pObj->RTEcounter.'";
				switch(type){
					case "link":
						var curr="";
						var act="page";
						var selURL="";
						var current="";
						node=tinyMCE.selectedElement;
						do {
							if (node.nodeName.toLowerCase() == "a" && tinyMCE.getAttrib(node, "href") != "") {
								curr=tinyMCE.getAttrib(node, "href");
								if(curr.indexOf("?id=")<0) {
									if(curr.indexOf("@")>-1) {
										act="mail";
									}
									else if(curr.indexOf("http://")>-1 || curr.indexOf("www.")>-1) {
										act="url";
									}
									current="&curUrl[href]="+tinyMCE.getAttrib(node, "href")+"&curURL[target]="+tinyMCE.getAttrib(node, "target");
								}
								else {
									var fz=curr.indexOf("?")+4;
									selURL=curr.substr(fz,curr.length);
									current="&P[currentValue]="+selURL;
								}
								break;
							}
						} while ((node = node.parentNode));
						template["file"] = "'.$this->httpTypo3Path.'typo3/browse_links.php?act="+act+"&mode=wizard&P[ext]=../'.t3lib_extMgm::siteRelPath("tinyrte").'&P[init]=tinyrte&P[formName]=editform"+current+"&P[itemName]=data%5B'.$table.'%5D%5B'.$row["uid"].'%5D%5B'.$field.'%5D_hr&P[fieldChangeFunc][setTheValue]=setTheValue%28\'link\',input,document.location.search%29%3B&P[fieldChangeFunc][TBE_EDITOR_fieldChanged]=TBE_EDITOR_fieldChanged%28%27'.$table.'%27%2C%27'.$row["uid"].'%27%2C%27'.$field.'%27%2C%27data%5B'.$table.'%5D%5B'.$row["uid"].'%5D%5B'.$field.'%5D%27%29%3B";
						tinyMCE.openWindow(template, {editor_id : editor_id, scrollbars : "yes", inline : "yes"});
						return false;

					case "image":
						template["file"] = "'.$this->Path.'rte_select_image.php?&RTEtsConfigParams='.$table.'%3A136%3A'.$field.'%3A29%3Atext%3A'.$row["pid"].'%3A";
						tinyMCE.openWindow(template, {editor_id : editor_id, scrollbars : "yes", inline : "yes"});
						return false;
				}
			}
			/**
			 * If an Link or Image selected, insert in the RTE
			 * This function is called from the Elementbrowser.
			 *
			 * type		: Link or Image
			 * value	: The value to be inserted
			 * act		: Needed for Links, to transform the kind of link (internal, external, file, email)
			 *
			 * The "act"-Value we become from the URL of the Elementbrowser
			 */ 
			function setTheValue(type,value,act) {
				switch(type){
					case "link":
						var prefixURL=getActivePagefromFilebrowser(act)
						var linkValue=value.split(" ");
						var linkURL=linkValue[0];
						var target=linkValue[1];
						if(target.indexOf("x")!=-1) { // Opens the link in a window with window.open....
							var winProp=target.split("x");
							var klick="window.open(\'"+prefixURL+linkURL+"\',\'popup\',\'height="+winProp[0]+",width="+winProp[1]+"\')";
							linkURL="#_";
							tinyMCE.insertLink(linkURL, "", "", klick);
						}
						else {
							tinyMCE.insertLink(prefixURL+linkURL, target);
						}
						return false;
					case "image":
						var imageProp=value.split("|");
						tinyMCE.insertImage(imageProp[0], "", "", "", "", imageProp[1], imageProp[2], "", "", "", "");
						TBE_EDITOR_fieldChanged(\''.$table.'\',\''.$row["uid"].'\',\''.$field.'\',\'data['.$table.']['.$row["uid"].']['.$field.']\');
						return false;
				}
			}

			/**
			 * What kind of link we get back?
	 		 */
			function getActivePagefromFilebrowser(act) {
				if(act.indexOf("act=page")>-1) {
					return "'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'?id=";
				}
				else if(act.indexOf("act=file")>-1) {
					return "";
				}
				else if(act.indexOf("act=url")>-1) {
					return "http://";
				}
				else if(act.indexOf("act=mail")>-1) {
					return "mailto:";
				}
				else {
					alert("Cant specify the kind of Link. Sorry!");
				}
				return;
			}
		</script>
		'.$this->triggerField($PA['itemFormElName']).'
		<textarea id="RTEarea'.$pObj->RTEcounter.'" name="'.htmlspecialchars($PA['itemFormElName']).'_hr" rows="15" cols="80">'.t3lib_div::formatForTextarea($value).'</textarea>';
		return $item;
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tinyrte/class.tx_tinyrte.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tinyrte/class.tx_tinyrte.php']);
}
?>